#include "listserv.h"
#include "protos.h"
#include "ListSERV_rev.h"

#define STARTUP "Amiga " VERS " -- written by by Peter Simons <simons@peti.GUN.de>\n"
#define USAGE   "USAGE: ListSERV <mailfile\n"

static char rcssid[] = "$Id: main.c,v 1.9.1.15 1993/12/29 07:26:54 simons Exp simons $";
static char dosid[] = VERSTAG;

FILE *mailer, *logfile;

long __stack = 1024*5;  /* In case the stack is too small, allocate a
                         * new one.             (SAS/C 6.3+)
                         */

int main(int argc, char **argv)
{
        char from[256];
        char buf[BUFSIZ];
        char grp[64];
        char dat[64];
        int i;
        int gotcommand = 0;
        int inheader;
        int log;
        int garbage = 0;

        printf(STARTUP);
        if (argc == 2 && (!strcmp(argv[1], "?") ||
                          !stricmp(argv[1], "-h"))) {
                printf(USAGE);
                return 0;
        }

        /* gotta have some default if the From: line is missing */
        strcpy(from, "ListServ");

        inheader = 1;
        while (fgets(buf,BUFSIZ,stdin) != NULL)
                {
                /* drop trailing newline */
                while (buf[(i=strlen(buf)-1)] == '\n')
                        buf[i] = '\0';

                if (strlen(buf) == 0)   /* blank line ends header */
                        {
                        inheader = 0;
                        continue;
                        }


                /*
                 * get the From: line so we can return the answer
                 *
                 * Note that we DON'T check that we're in the header when
                 * picking up the From: line; that's so that we'll take the
                 * last from line we encounter which makes it handle
                 * forwarded messages correctly.
                 */

                if (!strnicmp(buf,"From: ",6)) {
                        strcpy(from, &buf[6]);
                        ParseAddress(from);
                        continue;
                }

                /* don't look for commands in the header */
                if (inheader)
                        continue;

                /* avoid mail loops - ignore requests from ourself! */
                if (!strnicmp(from, "listserv", 8))
                        {
                        printf("I refuse to talk to myself.\n");
                        exit(0);
                        }

                /* Throw away bounced mail */
                if (strstr(from, "-daemon"))
                        {
                        printf("We don't do business with your type.\n");
                        exit(0);
                        }

                /* force to lower case and scan for commands
                p = buf;
                while (p && *p)
                        {
                        if (isupper(*p))
                                *p = tolower(*p);
                        p++;
                        }
                */

                /* log the request */
                LockFile(LOGFILE);
                log = open(LOGFILE, AFLAGS, AMODE);
                if (log == -1)
                        perror(LOGFILE);
                else
                        {
                        logfile = fdopen(log, "a");
                        if (logfile != NULL)
                                {
                                long clock = time(0);
                                strcpy(dat,ctime(&clock));
                                /* drop trailing newline */
                                while (dat[(i=strlen(dat)-1)] == '\n')
                                        dat[i] = '\0';
                                printf("logfile: %s|%s|%s\n", dat, from, buf);
                                fprintf(logfile,"%s|%s|%s\n", dat, from, buf);
                                fflush(logfile);
                                close(log);
                                }
                        else
                                perror(LOGFILE);
                        }
                UnLockFile(LOGFILE);

                if (!strnicmp(buf, "list ",5)
                || !strnicmp(buf, "delete-all ",11)
                || !strnicmp(buf, "del-all ",8)
                || !strnicmp(buf, "unsubscribe-all ",16)
                || !strnicmp(buf, "unsub-all ",10)
                || !stricmp(buf, "list")
                || !stricmp(buf, "delete-all")
                || !stricmp(buf, "del-all")
                || !stricmp(buf, "unsubscribe-all")
                || !stricmp(buf, "unsub-all"))
                        {
                        gotcommand++;
                        listsearch(from, buf);
                        continue;
                        }

                if (!strnicmp(buf,"add ", 4)
                || !strnicmp(buf,"subscribe ", 10)
                || !strnicmp(buf,"sub ",4))
                        {
                        gotcommand++;
                        subscription(from,buf,1);
                        continue;
                        }

                if (!strnicmp(buf,"delete ", 7)
                || !strnicmp(buf,"del ",4)
                || !strnicmp(buf,"unsubscribe ", 12)
                || !strnicmp(buf,"unsub ",6))
                        {
                        gotcommand++;
                        subscription(from,buf,0);
                        continue;
                        }

                if (!stricmp(buf,"index")
                || !stricmp(buf,"longindex"))
                        {
                        gotcommand++;
                        sendindex(from,buf,!stricmp(buf,"longindex"));
                        continue;
                        }

                if (!strnicmp(buf, "faq ", 4))
                        {
                        gotcommand++;
                        sendfaq(from, buf);
                        continue;
                        }

                if (!stricmp(buf, "faq"))
                        {
                        gotcommand++;
                        faqindex(from, buf);
                        continue;
                        }

                if (!stricmp(buf,"help"))
                        {
                        gotcommand++;
                        sendhelp(from,buf);
                        continue;
                        }

                if (!strnicmp(buf,"help ",5))
                        {
                        gotcommand++;
                        sscanf(buf,"%*s%s", grp);
                        listhelp(from, grp, buf);
                        continue;
                        }
                /* Flush message if > 5 lines of garbage */
                if (++garbage > 5)
                        {
                        printf("Garbled message, flushing...\n");
                        exit(0);
                        }
                }
        if (gotcommand == 0)
                sendhelp(from, "indecipherable");
        exit(0);
        }

void callmailer(char *carboncopy, char *toaddr, char *request)
{
        char cbuf[BUFSIZ];

        printf("callmailer \"%s\",\"%s\",\"%s\"\n", carboncopy, toaddr, request);

        strcpy(cbuf, MAILER);
        strcat(cbuf, " -f " LISTSERVADDR " -R \"Mailing List Processor\"");
        if (carboncopy && *carboncopy) {
                strcat(cbuf, " -c ");
                strcat(cbuf, carboncopy);
        }
        mailer = popen(cbuf,"w");
        printf("mailer popen '%s'\n", cbuf);
        if (mailer == NULL)
                {
                perror(cbuf);
                exit(1);
                }
        fprintf(mailer,"To: %s\n", toaddr);
        fprintf(mailer,"Subject: Re: your ListSERV request \"%s\"\n", request);
        fprintf(mailer,"X-ListSERV: Peti's Amiga " VERS "\n");
        fprintf(mailer,"\n");
}

void mailcat(char *mfname, char *prefix)
{
        FILE *mf;
        char buf[BUFSIZ];

        printf("mailcat \"%s\", \"%s\"\n", mfname, prefix);

        LockFile(mfname);
        mf = fopen(mfname,"r");
        if (mf == NULL)
                {
                UnLockFile(mfname);
                perror(mfname);
                fprintf(mailer,"This should have been the contents of\n");
                fprintf(mailer,"file '%s' but it's missing!\n",mfname);
                return;
                }

        /* copy the message file into the mailer */
        while (fgets(buf,BUFSIZ,mf) != NULL)
                {
                fputs(prefix,mailer);
                fputs(buf,mailer);
                }
        fclose(mf);
        UnLockFile(mfname);
        return;
}


void ParseAddress(char *line)
{
        int brackets, i, z;

        for (i = 0, z = 0, brackets = 0; line[i] != '\0'; i++) {
                if (line[i] == '(' && (i == 0 || isspace(line[i-1])))
                        brackets = 1;
                if (line[i] == ')' && (line[i+1] == '\0' || isspace(line[i+1])))
                        brackets = 0;
                if (line[i] == '<' && brackets == 0) {
                        i++;
                        while (1) {             /* Forever! */
                                if (line[i] == '>' && (line[i+1] == '\0' || isspace(line[i+1])))
                                        break;
                                line[z++] = line[i++];
                        }
                        line[z] = '\0';
                        break;
                }
        }
        if (z == 0) {   /* No <address> occured. */
                i = 0;
                while (!isspace(line[i]))
                        i++;
                line[i] = '\0';
        }
}

